<script>
  export let map;
  export let sources;

  import bbox from "@turf/bbox";
  import { featureCollection } from "@turf/helpers";

  function fitBounds(sourceId) {
    const features = map.querySourceFeatures(sourceId);
    if (features.length) {
      const bounds = bbox(featureCollection(features));
      map.fitBounds(bounds);
    }
  }
</script>

{#if sources}
  <ul class="my-4">
    {#each sources as { id, type, url, visible }}
      <li>
        <label>
          <input type="checkbox" bind:checked={visible} />
          <a href={url} rel="external" target="_blank">{id}</a>
          ({type})
          <button
            class="btn btn-secondary btn-sm"
            on:click={() => fitBounds(id)}
            disabled={!visible}>
            zoom
          </button>
        </label>
      </li>
    {/each}
  </ul>
{/if}
